<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2010 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <vitaly.hohlov@gmail.com>
 * @package Plugins
 */
/**************************************************************************/

class Groups_Admin extends A_MainFrame
{
  function __construct()
  {
    parent::__construct("plugin_groups.tpl");

	$this->AddJScript("/plugins/groups/admin/groups.js");
  }

  function Action($action)
  { $res=false;
    switch($action)
    { case "addgroup": $res=$this->AddGroup(); break;
	  case "editgroup": $res=$this->EditGroup(); break;
	  case "delgroup": $res=$this->DelGroup(); break;
	  case "up": $res=$this->Up(); break;
	  case "down": $res=$this->Down(); break;
	}
    if($res)
	A::goUrl("admin.php?mode=structures&item=".ITEM);
  }

  function AddGroup()
  {
    $access=array();
	A::$DB->query("SELECT * FROM ".getDomain(STRUCTURE)."_sections ORDER BY sort");
	while($row=A::$DB->fetchRow())
	{ $row['access']=array();
	  $row['access'][]=array('name'=>'read','caption'=>"Чтение",'auth'=>false);
	  if(function_exists($row['module']."_SpecialSectionAccess"))
	  { $section=getDomain(STRUCTURE)."_".$row['lang']."_".$row['name'];
	    call_user_func($row['module']."_SpecialSectionAccess",&$row['access'],$section);
	  }
	  elseif(function_exists($row['module']."_Access"))
	  call_user_func($row['module']."_Access",&$row['access']);
	  $access[$row['id']]=array();
	  foreach($row['access'] as $row2)
	  if(!empty($row2['name']) && isset($_REQUEST['s'.$row['id']."_".$row2['name']]))
	  $access[$row['id']][]=$row2['name'];
	}
	A::$DB->free();

    $_REQUEST['access']=serialize($access);
    $_REQUEST['name']=strip_tags($_REQUEST['name']);
	$_REQUEST['sort']=A::$DB->getOne("SELECT MAX(sort) FROM ".STRUCTURE)+1;
	$cs=A::$DB->getCount(STRUCTURE,"idsec>0");

	$dataset = new A_DataSet(STRUCTURE);
    $dataset->fields=array("name","idsec","access","sort");
    if($id=$dataset->Insert())
	{ if(!$cs && $section=getSectionById($_REQUEST['idsec']))
	  { $tables=A::$DB->getTables();
		if(in_array($section,$tables))
		A::$DB->Update($section,array('idgroup'=>$id),"idgroup=0");
	  }
	  return true;
	}
	else
	return false;
  }

  function EditGroup()
  {
    $access=array();
	A::$DB->query("SELECT * FROM ".getDomain(STRUCTURE)."_sections ORDER BY sort");
	while($row=A::$DB->fetchRow())
	{ $row['access']=array();
	  $row['access'][]=array('name'=>'read','caption'=>"Чтение",'auth'=>false);
	  if(function_exists($row['module']."_SpecialSectionAccess"))
	  { $section=getDomain(STRUCTURE)."_".$row['lang']."_".$row['name'];
	    call_user_func($row['module']."_SpecialSectionAccess",&$row['access'],$section);
	  }
	  elseif(function_exists($row['module']."_Access"))
	  call_user_func($row['module']."_Access",&$row['access']);
	  $access[$row['id']]=array();
	  foreach($row['access'] as $row2)
	  if(!empty($row2['name']) && isset($_REQUEST['s'.$row['id']."_".$row2['name']]))
	  $access[$row['id']][]=$row2['name'];
	}
	A::$DB->free();

	$_REQUEST['access']=serialize($access);
	$_REQUEST['name']=strip_tags($_REQUEST['name']);
	$cs=A::$DB->getCount(STRUCTURE,"idsec>0");

    $dataset = new A_DataSet(STRUCTURE);
    $dataset->fields=array("name","idsec","access");
    if($row=$dataset->Update())
	{ if(!$cs && $section=getSectionById($_REQUEST['idsec']))
	  { $tables=A::$DB->getTables();
		if(in_array($section,$tables))
		A::$DB->Update($section,array('idgroup'=>$row['id']),"idgroup=0");
	  }
	  return true;
	}
	else
	return false;
  }

  function DelGroup()
  {
	$dataset = new A_DataSet(STRUCTURE);
    if($row=$dataset->Delete())
	{ if($section=getSectionById($row['idsec']))
	  { $tables=A::$DB->getTables();
		if(in_array($section,$tables))
		A::$DB->Update($section,array('idgroup'=>0),"idgroup=".$row['id']);
	  }
	  return true;
	}
	else
	return false;
  }

  function Up()
  {
	if($row=A::$DB->getRowById($_REQUEST['id'],STRUCTURE))
	{ A::$DB->query("SELECT id,sort FROM ".STRUCTURE." WHERE sort<{$row['sort']} ORDER BY sort DESC LIMIT 0,1");
      $nextrow=A::$DB->fetchRow();
	  A::$DB->execute("UPDATE ".STRUCTURE." SET sort={$row['sort']} WHERE id={$nextrow['id']}");
	  A::$DB->execute("UPDATE ".STRUCTURE." SET sort={$nextrow['sort']} WHERE id={$row['id']}");
	  return true;
	}
	return false;
  }

  function Down()
  {
	if($row=A::$DB->getRowById($_REQUEST['id'],STRUCTURE))
	{ A::$DB->query("SELECT id,sort FROM ".STRUCTURE." WHERE sort>{$row['sort']} ORDER BY sort LIMIT 0,1");
      $prevrow=A::$DB->fetchRow();
	  A::$DB->execute("UPDATE ".STRUCTURE." SET sort={$row['sort']} WHERE id={$prevrow['id']}");
	  A::$DB->execute("UPDATE ".STRUCTURE." SET sort={$prevrow['sort']} WHERE id={$row['id']}");
	  return true;
	}
	return false;
  }

  function createData()
  {

	$minsort=A::$DB->getOne("SELECT MIN(sort) FROM ".STRUCTURE);
    $maxsort=A::$DB->getOne("SELECT MAX(sort) FROM ".STRUCTURE);

	$groups=array();
    A::$DB->query("
	SELECT g.*,s.caption AS section	FROM ".STRUCTURE." AS g
	LEFT JOIN ".getDomain(STRUCTURE)."_sections AS s ON s.id=g.idsec
	ORDER BY sort");
    while($row=A::$DB->fetchRow())
	{ $row['bsort']="";
	  if($row['sort']>$minsort)
	  $row['bsort'].=AddImageButtonLink("/templates/admin/images/up.gif","admin.php?mode=structures&item=".ITEM."&authcode=".A::$AUTH->authcode."&action=up&id=".$row['id'],"Вверх",16,16);
	  if($row['sort']<$maxsort)
	  $row['bsort'].=AddImageButtonLink("/templates/admin/images/down.gif","admin.php?mode=structures&item=".ITEM."&authcode=".A::$AUTH->authcode."&action=down&id=".$row['id'],"Вниз",16,16);
	  $groups[]=$row;
	}
	A::$DB->free();

	$this->Assign("groups",$groups);
  }
}

A::$MAINFRAME = new Groups_Admin;